/**************************************************************
	Electric sand timer
	dqv
	 for the 12F629/12F675
 **************************************************************
	author air_variable
	http://www.ne.jp/asahi/air/variable/
	Tools:
	MPLAB v8.88
	MPLAB XC8 ver1.11
---------------------------------------------------------------
Date	:Time	Version	Build	Note
20110830 22:00	1.00	---		Begin the program
20070816	--	1.10	---		correspond economy mode
20081218 	--	2.00	---		cirrespond Hitech PICC Pro lite mode
20111218 17:12	3.00	---		Ռmp~A{^(GP3)oɕύX
20121207 18:12	3.10	XC8		Re-compile by XC8

---------------------------------------------------------------
	Pin assignment:
	(1)Vdd					[PICKIT2-2] 
	(2)GPIO5	LED RED(neg)
	(3)NC
	(4)reset				[PICKIT2-1]	(Vpp) Vdd bitween resister 10Kohm
	(5)GPIO4	Piezo(neg)
	(6)GPIO1				[PICKIT2-5]
	(7)GPIO0				[PICKIT2-4]
	(8)Vss					[PICKIT2-3]

	
	PDdr܂BႢr[vҋ@ԂłB
	QDXCb`ƍr[vn߁AvJn܂B
	RDPb݂ŃNbNA1ɏłȂ܂B
	SDK莞ԁĩvOł͂RjoƁAԌo߂\A
	LED2b_Aҋ@Ԃɖ߂܂B

**************************************************************/

#include <htc.h>
#define MHz 000000
#define _XTAL_FREQ 4MHz

#define LED_RED		GPIO5	//active low
#define PIEZO		GPIO2	//active low
#define	SWITCH		GPIO3	//**3.00
#define SET_TIMER	3		//timer 3 minute
#define RESULT_BEEP	10		//result of beep times 10 times

__CONFIG(CP_OFF & BOREN_OFF & MCLRE_OFF & PWRTE_OFF & WDTE_OFF & FOSC_INTRCIO);	//Idoling current 0.06uA

//Delay 100msec --------------------------------
void Delay_100ms(unsigned char time){
	while(time--){
		__delay_ms(30);//total 100ms
		__delay_ms(30);
		__delay_ms(30);
		__delay_us(10000);//
	}
}

//Beep sound 4KHz--------------------------------
void beep_sound4k(unsigned int timer){
	while(timer--){
		PIEZO =1;
		__delay_us(120);
		PIEZO =0;
		__delay_us(120);
	}	
}
//Beep sound 2KHz--------------------------------
void beep_sound2k(unsigned int timer){
	while(timer--){
		PIEZO =1;
		__delay_us(255);
		PIEZO =0;
		__delay_us(255);
	}	
}
//Beep click sound --------------------------------
void beep_click(void){
	unsigned char temp=10;
	while(temp--){
		PIEZO =0;
		__delay_us(64);
		PIEZO =1;
		__delay_us(64);
	}	
}

//------------------main
void main(void){
 	unsigned int	temp;
	unsigned char	temp1,temp2;

//---------------------------------------------------------
//Initialization
//	OSCCAL = _READ_OSCCAL_DATA();	//OSCCAL AUTO SET
	GIE  = 0;						//Interrupt service is disable
	CMCON  = 7;						//GPIO use all digital port

//	ANSEL  =  	  0b00000000;		//when device is 12F675
				//  76543210
    TRISIO 	=     0b00001000;		//GPIO2 is OUTPUT
    GPIO	=     0b00001000;		//GPIO initialize

//---------------------------------------------------------
//Start up routiene
//power on opening Beep
	beep_sound2k(1000);
reset:	//---reset 
//Sleep check loop
	while(1){
	
//setup to sleep routiene
				//  76543210
		nGPPU =  0;				//internal pullup function use
		IOCB =    0b00001000;	//GPIO3 is listen mode
	    GPIO	= 0b00101000;	//GPIO setting (Piezo port is 1)
		GPIO = GPIO;			//Flash port
		GPIF  = 0;				//GPIF flag clear
		GPIE  = 1;				//sleep wake-up function is enable
									//vector non jump and execute next command
		SLEEP();				//sleep!
		NOP();					//Wake up
//--Wake-up start!
		__delay_ms(10);			//waiting stabilize port time

			
// Wakeup when GPIO0 is high 
	
		GPIE  = 0;	//sleep wake-up function is disable
		GPIF  = 0;	//GPIO int flag reset
		nGPPU  = 1;	//internal pullup function disable
	
	    TRISIO 	= 0b00001000;	//GPIO0 is OUTPUT
	    GPIO	= 0b00001000;	//GPIO initialize

//---------------------------------------------------------
//Begin at timer

		beep_sound4k(1000);
//Timer counter
		temp2 = SET_TIMER;		//minute
		while(temp2--){
			temp = 60;			//second count
//1sec timer
			while(temp--){
				LED_RED = 0;	//LED light
				Delay_100ms(2);
				LED_RED = 1;	//LED off
				Delay_100ms(7);
				__delay_ms(100);//adjustment total 1s
				beep_click();	//1 second sound click
				if (!SWITCH){
					beep_sound2k(500);
					LED_RED = 1;	//LED light
					beep_sound4k(500);
					LED_RED = 0;	//LED off
					beep_sound2k(500);
					LED_RED = 1;	//LED light
					beep_sound4k(500);
					LED_RED = 0;	//LED off
					while(!SWITCH);
					Delay_100ms(10);
					LED_RED = 1;	//LED light
					goto reset;
				}	
					
			}
		beep_sound4k(10);		//1 minute sound click
		}
//---------------------------------------------------------
//End of timer routiene
//Buzzer OUT (4KHz)
		LED_RED = 0;
		temp2 = RESULT_BEEP; //Beep
		while(temp2--){
			beep_sound4k(300);
			Delay_100ms(3);// Beep silent
		}

	Delay_100ms(20);

	}
}
		
